library circle2d;

import 'point.dart';

abstract class Abstract2DCircle<N extends num> implements Abstract2DPoint<N> {
	N get radius;
	N get diameter => 2 * radius;

	N get width => diameter;
	N get height => diameter;

	N get leftX => x - radius;
	N get rightX => x + radius;
	N get topY => y + radius;
	N get bottomY => y - radius;

	set leftX( N value ) => position.x = value + radius;
	set rightX( N value ) => position.x = value - radius;
	set topY( N value ) => position.y = value + radius;
	set bottomY( N value ) => position.y = value - radius;
}


class CustomDouble2DCircle extends CustomDouble2DPoint with Abstract2DCircle<double> {
	double _radius = 0.5;

	double get radius => _radius;
}