library point2d;

import 'shape.dart';
import '../vectors/abstract_vector.dart';
import '../vectors/double_vector.dart';

abstract class Abstract2DPoint<N extends num> extends Abstract2DShape<N> {
	Abstract2DVector<N> get position;

	N get leftX => x;
	N get rightX => x;
	N get topY => y;
	N get bottomY => y;

	set leftX( N value ) => position.x = value;
	set rightX( N value ) => position.x = value;
	set topY( N value ) => position.y = value;
	set bottomY( N value ) => position.y = value;
}


class CustomDouble2DPoint extends Abstract2DPoint<double> {
	final CustomDouble2DVector _position = new CustomDouble2DVector( 0.0, 0.0 );

	Abstract2DVector<double> get position => _position;

	double get x => _position.x;
	double get y => _position.y;

	Abstract2DVector<double> get size => NullDouble2DVector.instance;

	double get width => 0.0;
	double get height => 0.0;
}