library properties2d;

import 'dart:math';
import '../vectors/abstract_vector.dart';
import '../vectors/double_vector.dart';

class AngleAndSpeed2D {
	double _angle, _speed;

	AngleAndSpeed2D( double this._angle, double this._speed );

	double get angle => _angle;
	double get speed => _speed;
	double get horizontalSpeed => speed * cos( angle );
	double get verticalSpeed => speed * sin( angle );
}

class Speed2DVector {
	Abstract2DVector<double> _vector;

	Speed2DVector( double x, double y ) : _vector = new CustomDouble2DVector( x, y );

	double get angle => _vector.angle;
	double get speed => _vector.length;
	double get horizontalSpeed => _vector.x;
	double get verticalSpeed => _vector.y;
}