library shape2d;

import '../vectors/abstract_vector.dart';

abstract class Abstract2DShape<N extends num> {
	Abstract2DVector<N> get position;

	N get x => position.x;
	N get y => position.y;

	Abstract2DVector<N> get size;

	N get width => size.x;
	N get height => size.y;

	N get leftX => x - width;
	N get rightX => x + width;
	N get topY => y - height;
	N get bottomY => y + height;

	set leftX( N value );
	set rightX( N value );
	set topY( N value );
	set bottomY( N value );
}