library abstract_2d_space_partition_system;

import '../shapes/shape.dart';
import '../vectors/abstract_vector.dart';

abstract class Abstract2DSpacePartitioningSystem<N extends num> {
	void insertShape( Abstract2DShape<N> shape );

	void removeShape( Abstract2DShape<N> shape );

	void moveShape( Abstract2DShape<N> shape, Abstract2DVector<N> newPosition );

	void getNearbyShapes( Abstract2DShape<N> shape, List<Abstract2DShape<N>> list );

	List<Abstract2DShape<N>> getNearbyShapesList( Abstract2DShape<N> shape ) {
		List<Abstract2DShape<N>> list = new List<Abstract2DShape<N>>();
		getNearbyShapes( shape, list );
		return list;
	}
}


bool isPowerOf2( int num ) => num >= 1 && ( num & ( num - 1 ) ) == 0;

double minDouble = 0.0000000001;